Index: src/UIElements/QT4/QTDialog.hpp
===================================================================
--- src/UIElements/QT4/QTDialog.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/QT4/QTDialog.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -17,4 +17,5 @@
 class QDoubleSpinBox;
 class QLineEdit;
+class QListWidget;
 class QComboBox;
 class QDialogButtonBox;
@@ -22,9 +23,18 @@
 
 // Forward declarations for plumbing
+template<typename T> class QTQueryListPipe;
 class StringQTQueryPipe;
+class StringsQTQueryPipe;
 class IntQTQueryPipe;
 class DoubleQTQueryPipe;
+class DoublesQTQueryPipe;
+class AtomQTQueryPipe;
+class AtomsQTQueryPipe;
 class MoleculeQTQueryPipe;
+class MoleculesQTQueryPipe;
 class ElementQTQueryPipe;
+class ElementsQTQueryPipe;
+class VectorQTQueryPipe;
+class VectorsQTQueryPipe;
 
 class QTDialog : public QDialog, public Dialog
@@ -36,14 +46,20 @@
 
   virtual void queryEmpty(const char*, std::string);
-  virtual void queryBoolean(const char *, bool *, std::string = "");
-  virtual void queryInt(const char *, int *,std::string = "");
-  virtual void queryDouble(const char*,double *,std::string = "");
-  virtual void queryString(const char*, std::string *,std::string = "");
-  virtual void queryStrings(const char*, std::vector<std::string> *,std::string = "");
-  virtual void queryAtom(const char*,atom**,std::string = "");
-  virtual void queryMolecule(const char*,molecule**,std::string = "");
-  virtual void queryVector(const char*,Vector *,const double *const,bool,std::string = "");
-  virtual void queryBox(const char*,double ** const, std::string = "");
-  virtual void queryElement(const char*,std::vector<element *> *_target,std::string = "");
+  virtual void queryBoolean(const char *, std::string = "");
+  virtual void queryInt(const char *,std::string = "");
+  virtual void queryInts(const char *,std::string = "");
+  virtual void queryDouble(const char*,std::string = "");
+  virtual void queryDoubles(const char*,std::string = "");
+  virtual void queryString(const char*,std::string = "");
+  virtual void queryStrings(const char*,std::string = "");
+  virtual void queryAtom(const char*,std::string = "");
+  virtual void queryAtoms(const char*,std::string = "");
+  virtual void queryMolecule(const char*,std::string = "");
+  virtual void queryMolecules(const char*,std::string = "");
+  virtual void queryVector(const char*,bool,std::string = "");
+  virtual void queryVectors(const char*,bool,std::string = "");
+  virtual void queryBox(const char*, std::string = "");
+  virtual void queryElement(const char*,std::string = "");
+  virtual void queryElements(const char*,std::string = "");
 
   virtual bool display();
@@ -54,5 +70,5 @@
   class IntQTQuery : public Dialog::IntQuery {
     public:
-      IntQTQuery(std::string _title, int *_target,QBoxLayout *_parent,QTDialog *_dialog);
+      IntQTQuery(std::string _title,QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~IntQTQuery();
       virtual bool handle();
@@ -66,7 +82,24 @@
     };
 
+  class IntsQTQuery : public Dialog::IntsQuery {
+    public:
+      IntsQTQuery(std::string _title,QBoxLayout *_parent,QTDialog *_dialog);
+      virtual ~IntsQTQuery();
+      virtual bool handle();
+      void IntegerEntered(const QString&);
+      void IntegerSelected();
+      void AddInteger();
+      void RemoveInteger();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+
+      QTQueryListPipe<int> *pipe;
+    };
+
     class DoubleQTQuery : public Dialog::DoubleQuery {
     public:
-      DoubleQTQuery(std::string title, double *_target,QBoxLayout *_parent,QTDialog *_dialog);
+      DoubleQTQuery(std::string title,QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~DoubleQTQuery();
       virtual bool handle();
@@ -80,7 +113,21 @@
     };
 
+    class DoublesQTQuery : public Dialog::DoublesQuery {
+    public:
+      DoublesQTQuery(std::string title,QBoxLayout *_parent,QTDialog *_dialog);
+      virtual ~DoublesQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QDoubleSpinBox *inputBox;
+
+      QTQueryListPipe<double> *pipe;
+    };
+
     class StringQTQuery : public Dialog::StringQuery {
     public:
-      StringQTQuery(std::string _title, std::string *_target, QBoxLayout *_parent,QTDialog *_dialog);
+      StringQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~StringQTQuery();
       virtual bool handle();
@@ -96,5 +143,5 @@
     class StringsQTQuery : public Dialog::StringsQuery {
     public:
-      StringsQTQuery(std::string _title, std::vector<std::string> *_target, QBoxLayout *_parent,QTDialog *_dialog);
+      StringsQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~StringsQTQuery();
       virtual bool handle();
@@ -105,10 +152,38 @@
       QLineEdit *inputBox;
 
-      StringQTQueryPipe *pipe;
+      QTQueryListPipe<std::string> *pipe;
+    };
+
+    class AtomQTQuery : public Dialog::AtomQuery {
+    public:
+      AtomQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
+      virtual ~AtomQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      AtomQTQueryPipe *pipe;
+    };
+
+    class AtomsQTQuery : public Dialog::AtomsQuery {
+    public:
+      AtomsQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
+      virtual ~AtomsQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      AtomsQTQueryPipe *pipe;
     };
 
     class MoleculeQTQuery : public Dialog::MoleculeQuery {
     public:
-      MoleculeQTQuery(std::string _title, molecule **_target, QBoxLayout *_parent,QTDialog *_dialog);
+      MoleculeQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~MoleculeQTQuery();
       virtual bool handle();
@@ -122,7 +197,21 @@
     };
 
+    class MoleculesQTQuery : public Dialog::MoleculesQuery {
+    public:
+      MoleculesQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
+      virtual ~MoleculesQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      MoleculesQTQueryPipe *pipe;
+    };
+
     class VectorQTQuery : public Dialog::VectorQuery {
     public:
-      VectorQTQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check,QBoxLayout *,QTDialog *);
+      VectorQTQuery(std::string title,bool _check,QBoxLayout *,QTDialog *);
       virtual ~VectorQTQuery();
       virtual bool handle();
@@ -132,14 +221,31 @@
       QLabel *titleLabel;
       QBoxLayout *subLayout;
-      QBoxLayout *coordLayout[3];
-      QLabel *coordLabel[3];
-      QDoubleSpinBox *coordInput[3];
-
-      DoubleQTQueryPipe *pipe[3];
+      QBoxLayout *coordLayout;
+      QLabel *coordLabel;
+      QDoubleSpinBox *coordInput;
+
+      VectorQTQueryPipe *pipe;
+    };
+
+    class VectorsQTQuery : public Dialog::VectorsQuery {
+    public:
+      VectorsQTQuery(std::string title,bool _check,QBoxLayout *,QTDialog *);
+      virtual ~VectorsQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *mainLayout;
+      QLabel *titleLabel;
+      QBoxLayout *subLayout;
+      QBoxLayout *coordLayout;
+      QLabel *coordLabel;
+      QDoubleSpinBox *coordInput;
+
+      VectorsQTQueryPipe *pipe;
     };
 
     class ElementQTQuery : public Dialog::ElementQuery {
     public:
-      ElementQTQuery(std::string _title, std::vector<element *> *_target, QBoxLayout *_parent, QTDialog *_dialog);
+      ElementQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog);
       virtual ~ElementQTQuery();
       virtual bool handle();
@@ -151,4 +257,18 @@
 
       ElementQTQueryPipe *pipe;
+    };
+
+    class ElementsQTQuery : public Dialog::ElementsQuery {
+    public:
+      ElementsQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog);
+      virtual ~ElementsQTQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      ElementsQTQueryPipe *pipe;
     };
 
@@ -164,4 +284,27 @@
 // since MOC doesn't like nested classes
 
+
+template<typename T> class QTQueryListPipe : public QWidget {
+  public:
+    QTQueryListPipe(std::vector<T> *_content, QTDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton);
+    virtual ~QTQueryListPipe();
+    void AddInteger();
+    void RemoveInteger();
+    void IntegerSelected();
+    void IntegerEntered(const QString&);
+
+  private:
+    void AddValue(T item);
+    void RemoveRow(int row);
+
+    std::vector<T> *content;
+    QTDialog *dialog;
+    QLineEdit *inputBox;
+    QListWidget *inputList;
+    QPushButton *AddButton;
+    QPushButton *RemoveButton;
+};
+
+
 class StringQTQueryPipe : public QWidget {
   Q_OBJECT
@@ -194,4 +337,5 @@
 };
 
+
 class DoubleQTQueryPipe : public QWidget {
   Q_OBJECT
@@ -209,4 +353,37 @@
 };
 
+class AtomQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  AtomQTQueryPipe(atom **_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~AtomQTQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  atom **content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+
+};
+
+
+class AtomsQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  AtomsQTQueryPipe(std::vector<atom *>*_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~AtomsQTQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  std::vector<atom *>*content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+
+};
+
 class MoleculeQTQueryPipe : public QWidget {
   Q_OBJECT
@@ -225,8 +402,54 @@
 };
 
+class MoleculesQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  MoleculesQTQueryPipe(std::vector<molecule *>*_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~MoleculesQTQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  std::vector<molecule *>*content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+
+};
+
+class VectorQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  VectorQTQueryPipe(Vector *_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~VectorQTQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  Vector *content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+};
+
+class VectorsQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  VectorsQTQueryPipe(std::vector<Vector>*_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~VectorsQTQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  std::vector<Vector> *content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+};
+
 class ElementQTQueryPipe : public QWidget {
   Q_OBJECT
 public:
-  ElementQTQueryPipe(std::vector<element *> *_content, QTDialog *_dialog, QComboBox *_theBox);
+  ElementQTQueryPipe(const element **_content, QTDialog *_dialog, QComboBox *_theBox);
   virtual ~ElementQTQueryPipe();
 
@@ -235,5 +458,20 @@
 
 private:
-  std::vector<element *> *content;
+  const element **content;
+  QTDialog *dialog;
+  QComboBox *theBox;
+};
+
+class ElementsQTQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  ElementsQTQueryPipe(std::vector<const element *>*_content, QTDialog *_dialog, QComboBox *_theBox);
+  virtual ~ElementsQTQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  std::vector<const element *>*content;
   QTDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/QT4/QTMainWindow.cpp
===================================================================
--- src/UIElements/QT4/QTMainWindow.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/QT4/QTMainWindow.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "QTMainWindow.hpp"
@@ -19,6 +24,9 @@
 #include<boost/bind.hpp>
 
+#include "Helpers/MemDebug.hpp"
+
 #include "atom.hpp"
 #include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
 #include "Actions/Action.hpp"
 #include "Actions/ActionRegistry.hpp"
@@ -31,6 +39,4 @@
 #include "Views/QT4/QTMoleculeView.hpp"
 #include "Views/QT4/QTStatusBar.hpp"
-#include "Helpers/MemDebug.hpp"
-
 
 using namespace std;
Index: src/UIElements/QT4/QTUIFactory.cpp
===================================================================
--- src/UIElements/QT4/QTUIFactory.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/QT4/QTUIFactory.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,22 +6,30 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include <iostream>
 #include <cassert>
 
-using namespace std;
+#include <qapplication.h>
 
-#include <qapplication.h>
 
 #include "UIElements/QT4/QTUIFactory.hpp"
 #include "UIElements/QT4/QTMainWindow.hpp"
 #include "UIElements/QT4/QTDialog.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
 #include "version.h"
 #include "defs.hpp"
-#include "Helpers/MemDebug.hpp"
 
-QTUIFactory::QTUIFactory()
+using namespace std;
+
+QTUIFactory::QTUIFactory() :
+  argc(1)
 {
   // For now we just fake the command line parameters to make QT happy
-  argc=1;
   argv = new char*[1];
   argv[0] = new char[256];
